#include "lois.hxx"
#include "simulator.hxx"

#include <fstream>
#include <list>


int main() {

  int       i;

  // declaration des genereteurs uniformes
  UnifGen   gen0(17,3,5,8);
  UnifGen   gen1(MSG_M,MSG_A,MSG_C,MSG_G0);
  UnifGen   gen2(NAG_M,NAG_A,NAG_C,NAG_G0);


  // Test du LCG bidon
  cerr << "Test du LCG experimental " << endl;
  gen0.test();

  // Test du Minimal Standard Generator
  cerr << "Test du Minimal Standard Generator " << endl;
  gen1.test();

  // Test du NAG's Generator 
  cerr << "Test du NAG's Generator " << endl;
  gen2.test();


  // Generation de v.a. exponentiellement distribues
  cerr << "Generation de nombres aleatoires exponentiellement distribues" << endl;

  ExpoGen         exp_gen( 0.5 );
  ofstream        outFile("expo.m");

  if ( !outFile ) { cerr << "creation of output file failed\n";  return -1;  }

  // CALCULER ICI LA FONCTION DE REPARTITION EMPIRIQUE DE LA DISTRIBUTION EXPONENTIELLE
  // ET ECRIRE LES VALEURS DE CETTE FONCTION DANS LE FICHIER "expo.m".                 
  //                                                                                   
  // VOUS POUVEZ UTILISER UNE LISTE DE double POUR STOCKER PUIS TRIER LES ECHANTILLONS 
  // GENERES. VOICI UN EXEMPLE D'UTILISATION                                           
  // list<double>    randList;                                                         
  // list<double>::iterator it;                                                        
  // randList.push_back( 0.1 );  -> insertion de 0.1 dans la liste                     
  // randList.push_back( 0.05 ); -> insertion de 0.05 dans la liste                    
  // randList.sort();  -> tri par ordre croissant de la liste                          
  // for ( it = randList.begin(); it != randList.end(); it++) cerr << *it  -> affichage du contenu 




  //simulation d'une file M/M/1
  cerr << "\n\nSIMULATION M/M/1 AVEC " << 1000 << " TRAJECTOIRES" << endl;

  Simulator  sim(400.0, 0.5, 1000, 0.8, 1.0, 200);
  sim.run();
  sim.printTrajectory("sim.m");
  sim.printStationaryParameters();

  return 0;
}
